import { BindParams, DatabaseHolder, QueryExecResult, Recorder, Schema, SqlLite } from "../../types";
export declare const createQueryFromSchema: (schema: Schema) => [string, Array<string>];
export declare const database: DatabaseHolder;
export declare const createSQL: (path: string, schema: Schema) => Promise<SqlLite | undefined>;
export declare const getDatabase: () => SqlLite | null;
export declare const readingQueryMatch: (query: string, tables: Array<string>) => RegExpMatchArray | null;
export declare const writingQueryMatch: (query: string, tables: Array<string>) => RegExpMatchArray | null;
export declare const tableFromReadQuery: (query: string, tables: Array<string>) => string | null;
export declare const tableFromWritingQuery: (query: string, tables: Array<string>) => string | null;
export declare const registerQueryListeners: (updateState: (time: number) => void, query: string, tables: Array<string>, recorder: Recorder) => void;
export declare const triggerActuators: (query: string, tables: Array<string>, recorder: Recorder) => void;
export declare const executeQuery: (query: string, params?: BindParams | undefined) => Array<QueryExecResult> | undefined;
export declare const queryPipeline: (updateStateFn: (time: number) => void, query: string, params?: BindParams | undefined) => Array<QueryExecResult> | undefined;
export declare const insertQueryPipeline: (updateStateFn: (time: number) => void, query: string, params?: BindParams | undefined, recorder?: Recorder) => Array<QueryExecResult> | undefined;
declare const _default: {
    createQueryFromSchema: (schema: Schema) => [string, string[]];
    createSQL: (path: string, schema: Schema) => Promise<SqlLite | undefined>;
    queryPipeline: (updateStateFn: (time: number) => void, query: string, params?: BindParams | undefined) => QueryExecResult[] | undefined;
    insertQueryPipeline: (updateStateFn: (time: number) => void, query: string, params?: BindParams | undefined, recorder?: Recorder) => QueryExecResult[] | undefined;
};
export default _default;
